#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.16.142.2 $
#
#   last change: $Author: vg $ $Date: 2005/06/17 09:35:40 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..

PRJNAME=xmloff
TARGET=xo
TARGET_FILTER=xof

# --- Settings -----------------------------------------------------

.INCLUDE :  settings.mk

# --- Allgemein ----------------------------------------------------
NO_BSYMBOLIC=TRUE
ENABLE_EXCEPTIONS=TRUE

LIB1TARGET= $(SLB)$/xo.lib
LIB1FILES=	\
    $(SLB)$/core.lib \
    $(SLB)$/meta.lib \
    $(SLB)$/script.lib \
    $(SLB)$/style.lib \
    $(SLB)$/text.lib \
    $(SLB)$/draw.lib \
    $(SLB)$/chart.lib \
	$(SLB)$/forms.lib

# --- Shared-Library -----------------------------------------------

.IF "$(GUI)"!="UNX"
LIB4TARGET= $(LB)$/ixo.lib
LIB4FILES=	$(LB)$/_ixo.lib
LIB4OBJFILES=\
	$(OBJ)$/xmlkywd.obj
.ENDIF

SHL1TARGET= xo$(UPD)$(DLLPOSTFIX)
SHL1IMPLIB= _ixo

SHL1STDLIBS= \
		$(SVTOOLLIB)	\
		$(TOOLSLIB)		\
		$(VOSLIB)		\
		$(CPPULIB)		\
		$(CPPUHELPERLIB)\
		$(COMPHELPERLIB)\
		$(RTLLIB)		\
		$(SVLIB)		\
		$(TKLIB)		\
		$(SVLLIB)		\
		$(SALLIB)		\
		$(UNOTOOLSLIB)	\
		$(ONELIB)		\
		$(GOODIESLIB)

# SCO: the linker does know about weak symbols, but we can't ignore multiple defined symbols
.IF "(OS)"=="SCO" || "$(OS)$(COM)"=="OS2GCC"
SHL1STDLIBS+=-licg617mxp
.ENDIF

SHL1DEF=    $(MISC)$/$(SHL1TARGET).def
SHL1LIBS=   $(LIB1TARGET)


#SHL5TARGET= $(TARGET_FILTER)$(UPD)$(DLLPOSTFIX)
#SHL5IMPLIB= _i$(TARGET_FILTER)

#SHL5STDLIBS= \
		$(TOOLSLIB)         \
		$(RTLLIB)           \
		$(SALLIB)           \
		$(SALHELPERLIB)     \
		$(CPPULIB)          \
		$(CPPUHELPERLIB)    \
		$(ONELIB)           \
		$(COMPHELPERLIB)

#.IF "$(GUI)"=="UNX" || "$(GUI)"=="MAC"
#    SHL5STDLIBS += -lxo$(OFFICEUPD)$(DLLPOSTFIX)
#.ELSE
#    SHL5STDLIBS += $(LIBPRE) ixo.lib
#.ENDIF

#SHL5DEF=    $(MISC)$/$(SHL5TARGET).def
#SHL5LIBS=   $(LIB5TARGET)

#SHL5VERSIONMAP=$(TARGET_FILTER).map 

# --- Static-Lib ---------------------------------------------------------

.IF "$(SVXLIGHT)" != "" 
LIB2TARGET= $(LB)$/xol.lib
LIB2ARCHIV= $(LB)$/libxol.a
LIB2FILES=  \
			$(LB)$/sxl_core.lib\
			$(LB)$/sxl_meta.lib\
			$(LB)$/sxl_draw.lib\
			$(LB)$/sxl_forms.lib\
		    $(LB)$/sxl_script.lib\
			$(LB)$/sxl_style.lib\
			$(LB)$/sxl_text.lib
.ENDIF

# --- Def-File ---------------------------------------------------------

DEF1NAME    =$(SHL1TARGET)
DEF1DEPN    =$(MISC)$/$(SHL1TARGET).flt
DEFLIB1NAME =xo
DEF1DES     =XML Office Lib
DEF1EXPORTFILE=	exports.dxp

#DEF5NAME    =$(SHL5TARGET)


# --- Targets ----------------------------------------------------------

.INCLUDE :  target.mk

# --- Filter -----------------------------------------------------------

$(MISC)$/$(SHL1TARGET).flt: makefile.mk
	+$(TYPE) xo.flt > $@

