/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM /work/mozilla/mozilla/security/manager/ssl/public/nsIPKCS11Slot.idl
 */

#ifndef __gen_nsIPKCS11Slot_h__
#define __gen_nsIPKCS11Slot_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIEnumerator_h__
#include "nsIEnumerator.h"
#endif

#ifndef __gen_nsIPK11TokenDB_h__
#include "nsIPK11TokenDB.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
#define NS_PKCS11MODULEDB_CONTRACTID "@mozilla.org/security/pkcs11moduledb;1"

/* starting interface:    nsIPKCS11Slot */
#define NS_IPKCS11SLOT_IID_STR "c2d4f296-ee60-11d4-998b-00b0d02354a0"

#define NS_IPKCS11SLOT_IID \
  {0xc2d4f296, 0xee60, 0x11d4, \
    { 0x99, 0x8b, 0x00, 0xb0, 0xd0, 0x23, 0x54, 0xa0 }}

class NS_NO_VTABLE nsIPKCS11Slot : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IPKCS11SLOT_IID)

  /* readonly attribute wstring name; */
  NS_IMETHOD GetName(PRUnichar * *aName) = 0;

  /* readonly attribute wstring desc; */
  NS_IMETHOD GetDesc(PRUnichar * *aDesc) = 0;

  /* readonly attribute wstring manID; */
  NS_IMETHOD GetManID(PRUnichar * *aManID) = 0;

  /* readonly attribute wstring HWVersion; */
  NS_IMETHOD GetHWVersion(PRUnichar * *aHWVersion) = 0;

  /* readonly attribute wstring FWVersion; */
  NS_IMETHOD GetFWVersion(PRUnichar * *aFWVersion) = 0;

  enum { SLOT_DISABLED = 0U };

  enum { SLOT_NOT_PRESENT = 1U };

  enum { SLOT_UNINITIALIZED = 2U };

  enum { SLOT_NOT_LOGGED_IN = 3U };

  enum { SLOT_LOGGED_IN = 4U };

  enum { SLOT_READY = 5U };

  /* readonly attribute unsigned long status; */
  NS_IMETHOD GetStatus(PRUint32 *aStatus) = 0;

  /* nsIPK11Token getToken (); */
  NS_IMETHOD GetToken(nsIPK11Token **_retval) = 0;

  /* readonly attribute wstring tokenName; */
  NS_IMETHOD GetTokenName(PRUnichar * *aTokenName) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPKCS11SLOT \
  NS_IMETHOD GetName(PRUnichar * *aName); \
  NS_IMETHOD GetDesc(PRUnichar * *aDesc); \
  NS_IMETHOD GetManID(PRUnichar * *aManID); \
  NS_IMETHOD GetHWVersion(PRUnichar * *aHWVersion); \
  NS_IMETHOD GetFWVersion(PRUnichar * *aFWVersion); \
  NS_IMETHOD GetStatus(PRUint32 *aStatus); \
  NS_IMETHOD GetToken(nsIPK11Token **_retval); \
  NS_IMETHOD GetTokenName(PRUnichar * *aTokenName); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPKCS11SLOT(_to) \
  NS_IMETHOD GetName(PRUnichar * *aName) { return _to GetName(aName); } \
  NS_IMETHOD GetDesc(PRUnichar * *aDesc) { return _to GetDesc(aDesc); } \
  NS_IMETHOD GetManID(PRUnichar * *aManID) { return _to GetManID(aManID); } \
  NS_IMETHOD GetHWVersion(PRUnichar * *aHWVersion) { return _to GetHWVersion(aHWVersion); } \
  NS_IMETHOD GetFWVersion(PRUnichar * *aFWVersion) { return _to GetFWVersion(aFWVersion); } \
  NS_IMETHOD GetStatus(PRUint32 *aStatus) { return _to GetStatus(aStatus); } \
  NS_IMETHOD GetToken(nsIPK11Token **_retval) { return _to GetToken(_retval); } \
  NS_IMETHOD GetTokenName(PRUnichar * *aTokenName) { return _to GetTokenName(aTokenName); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPKCS11SLOT(_to) \
  NS_IMETHOD GetName(PRUnichar * *aName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetName(aName); } \
  NS_IMETHOD GetDesc(PRUnichar * *aDesc) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDesc(aDesc); } \
  NS_IMETHOD GetManID(PRUnichar * *aManID) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetManID(aManID); } \
  NS_IMETHOD GetHWVersion(PRUnichar * *aHWVersion) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetHWVersion(aHWVersion); } \
  NS_IMETHOD GetFWVersion(PRUnichar * *aFWVersion) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFWVersion(aFWVersion); } \
  NS_IMETHOD GetStatus(PRUint32 *aStatus) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStatus(aStatus); } \
  NS_IMETHOD GetToken(nsIPK11Token **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetToken(_retval); } \
  NS_IMETHOD GetTokenName(PRUnichar * *aTokenName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTokenName(aTokenName); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPKCS11Slot : public nsIPKCS11Slot
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPKCS11SLOT

  nsPKCS11Slot();
  virtual ~nsPKCS11Slot();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsPKCS11Slot, nsIPKCS11Slot)

nsPKCS11Slot::nsPKCS11Slot()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsPKCS11Slot::~nsPKCS11Slot()
{
  /* destructor code */
}

/* readonly attribute wstring name; */
NS_IMETHODIMP nsPKCS11Slot::GetName(PRUnichar * *aName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring desc; */
NS_IMETHODIMP nsPKCS11Slot::GetDesc(PRUnichar * *aDesc)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring manID; */
NS_IMETHODIMP nsPKCS11Slot::GetManID(PRUnichar * *aManID)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring HWVersion; */
NS_IMETHODIMP nsPKCS11Slot::GetHWVersion(PRUnichar * *aHWVersion)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring FWVersion; */
NS_IMETHODIMP nsPKCS11Slot::GetFWVersion(PRUnichar * *aFWVersion)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute unsigned long status; */
NS_IMETHODIMP nsPKCS11Slot::GetStatus(PRUint32 *aStatus)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIPK11Token getToken (); */
NS_IMETHODIMP nsPKCS11Slot::GetToken(nsIPK11Token **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring tokenName; */
NS_IMETHODIMP nsPKCS11Slot::GetTokenName(PRUnichar * *aTokenName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIPKCS11Module */
#define NS_IPKCS11MODULE_IID_STR "8a44bdf9-d1a5-4734-bd5a-34ed7fe564c2"

#define NS_IPKCS11MODULE_IID \
  {0x8a44bdf9, 0xd1a5, 0x4734, \
    { 0xbd, 0x5a, 0x34, 0xed, 0x7f, 0xe5, 0x64, 0xc2 }}

class NS_NO_VTABLE nsIPKCS11Module : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IPKCS11MODULE_IID)

  /* readonly attribute wstring name; */
  NS_IMETHOD GetName(PRUnichar * *aName) = 0;

  /* readonly attribute wstring libName; */
  NS_IMETHOD GetLibName(PRUnichar * *aLibName) = 0;

  /* nsIPKCS11Slot findSlotByName (in wstring name); */
  NS_IMETHOD FindSlotByName(const PRUnichar *name, nsIPKCS11Slot **_retval) = 0;

  /* nsIEnumerator listSlots (); */
  NS_IMETHOD ListSlots(nsIEnumerator **_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPKCS11MODULE \
  NS_IMETHOD GetName(PRUnichar * *aName); \
  NS_IMETHOD GetLibName(PRUnichar * *aLibName); \
  NS_IMETHOD FindSlotByName(const PRUnichar *name, nsIPKCS11Slot **_retval); \
  NS_IMETHOD ListSlots(nsIEnumerator **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPKCS11MODULE(_to) \
  NS_IMETHOD GetName(PRUnichar * *aName) { return _to GetName(aName); } \
  NS_IMETHOD GetLibName(PRUnichar * *aLibName) { return _to GetLibName(aLibName); } \
  NS_IMETHOD FindSlotByName(const PRUnichar *name, nsIPKCS11Slot **_retval) { return _to FindSlotByName(name, _retval); } \
  NS_IMETHOD ListSlots(nsIEnumerator **_retval) { return _to ListSlots(_retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPKCS11MODULE(_to) \
  NS_IMETHOD GetName(PRUnichar * *aName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetName(aName); } \
  NS_IMETHOD GetLibName(PRUnichar * *aLibName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLibName(aLibName); } \
  NS_IMETHOD FindSlotByName(const PRUnichar *name, nsIPKCS11Slot **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->FindSlotByName(name, _retval); } \
  NS_IMETHOD ListSlots(nsIEnumerator **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->ListSlots(_retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPKCS11Module : public nsIPKCS11Module
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPKCS11MODULE

  nsPKCS11Module();
  virtual ~nsPKCS11Module();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsPKCS11Module, nsIPKCS11Module)

nsPKCS11Module::nsPKCS11Module()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsPKCS11Module::~nsPKCS11Module()
{
  /* destructor code */
}

/* readonly attribute wstring name; */
NS_IMETHODIMP nsPKCS11Module::GetName(PRUnichar * *aName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute wstring libName; */
NS_IMETHODIMP nsPKCS11Module::GetLibName(PRUnichar * *aLibName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIPKCS11Slot findSlotByName (in wstring name); */
NS_IMETHODIMP nsPKCS11Module::FindSlotByName(const PRUnichar *name, nsIPKCS11Slot **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIEnumerator listSlots (); */
NS_IMETHODIMP nsPKCS11Module::ListSlots(nsIEnumerator **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIPKCS11ModuleDB */
#define NS_IPKCS11MODULEDB_IID_STR "ff9fbcd7-9517-4334-b97a-ceed78909974"

#define NS_IPKCS11MODULEDB_IID \
  {0xff9fbcd7, 0x9517, 0x4334, \
    { 0xb9, 0x7a, 0xce, 0xed, 0x78, 0x90, 0x99, 0x74 }}

class NS_NO_VTABLE nsIPKCS11ModuleDB : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IPKCS11MODULEDB_IID)

  /* nsIPKCS11Module getInternal (); */
  NS_IMETHOD GetInternal(nsIPKCS11Module **_retval) = 0;

  /* nsIPKCS11Module getInternalFIPS (); */
  NS_IMETHOD GetInternalFIPS(nsIPKCS11Module **_retval) = 0;

  /* nsIPKCS11Module findModuleByName (in wstring name); */
  NS_IMETHOD FindModuleByName(const PRUnichar *name, nsIPKCS11Module **_retval) = 0;

  /* nsIPKCS11Slot findSlotByName (in wstring name); */
  NS_IMETHOD FindSlotByName(const PRUnichar *name, nsIPKCS11Slot **_retval) = 0;

  /* nsIEnumerator listModules (); */
  NS_IMETHOD ListModules(nsIEnumerator **_retval) = 0;

  /* void toggleFIPSMode (); */
  NS_IMETHOD ToggleFIPSMode(void) = 0;

  /* readonly attribute boolean isFIPSEnabled; */
  NS_IMETHOD GetIsFIPSEnabled(PRBool *aIsFIPSEnabled) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPKCS11MODULEDB \
  NS_IMETHOD GetInternal(nsIPKCS11Module **_retval); \
  NS_IMETHOD GetInternalFIPS(nsIPKCS11Module **_retval); \
  NS_IMETHOD FindModuleByName(const PRUnichar *name, nsIPKCS11Module **_retval); \
  NS_IMETHOD FindSlotByName(const PRUnichar *name, nsIPKCS11Slot **_retval); \
  NS_IMETHOD ListModules(nsIEnumerator **_retval); \
  NS_IMETHOD ToggleFIPSMode(void); \
  NS_IMETHOD GetIsFIPSEnabled(PRBool *aIsFIPSEnabled); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPKCS11MODULEDB(_to) \
  NS_IMETHOD GetInternal(nsIPKCS11Module **_retval) { return _to GetInternal(_retval); } \
  NS_IMETHOD GetInternalFIPS(nsIPKCS11Module **_retval) { return _to GetInternalFIPS(_retval); } \
  NS_IMETHOD FindModuleByName(const PRUnichar *name, nsIPKCS11Module **_retval) { return _to FindModuleByName(name, _retval); } \
  NS_IMETHOD FindSlotByName(const PRUnichar *name, nsIPKCS11Slot **_retval) { return _to FindSlotByName(name, _retval); } \
  NS_IMETHOD ListModules(nsIEnumerator **_retval) { return _to ListModules(_retval); } \
  NS_IMETHOD ToggleFIPSMode(void) { return _to ToggleFIPSMode(); } \
  NS_IMETHOD GetIsFIPSEnabled(PRBool *aIsFIPSEnabled) { return _to GetIsFIPSEnabled(aIsFIPSEnabled); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPKCS11MODULEDB(_to) \
  NS_IMETHOD GetInternal(nsIPKCS11Module **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetInternal(_retval); } \
  NS_IMETHOD GetInternalFIPS(nsIPKCS11Module **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetInternalFIPS(_retval); } \
  NS_IMETHOD FindModuleByName(const PRUnichar *name, nsIPKCS11Module **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->FindModuleByName(name, _retval); } \
  NS_IMETHOD FindSlotByName(const PRUnichar *name, nsIPKCS11Slot **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->FindSlotByName(name, _retval); } \
  NS_IMETHOD ListModules(nsIEnumerator **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->ListModules(_retval); } \
  NS_IMETHOD ToggleFIPSMode(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->ToggleFIPSMode(); } \
  NS_IMETHOD GetIsFIPSEnabled(PRBool *aIsFIPSEnabled) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsFIPSEnabled(aIsFIPSEnabled); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPKCS11ModuleDB : public nsIPKCS11ModuleDB
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPKCS11MODULEDB

  nsPKCS11ModuleDB();
  virtual ~nsPKCS11ModuleDB();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsPKCS11ModuleDB, nsIPKCS11ModuleDB)

nsPKCS11ModuleDB::nsPKCS11ModuleDB()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsPKCS11ModuleDB::~nsPKCS11ModuleDB()
{
  /* destructor code */
}

/* nsIPKCS11Module getInternal (); */
NS_IMETHODIMP nsPKCS11ModuleDB::GetInternal(nsIPKCS11Module **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIPKCS11Module getInternalFIPS (); */
NS_IMETHODIMP nsPKCS11ModuleDB::GetInternalFIPS(nsIPKCS11Module **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIPKCS11Module findModuleByName (in wstring name); */
NS_IMETHODIMP nsPKCS11ModuleDB::FindModuleByName(const PRUnichar *name, nsIPKCS11Module **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIPKCS11Slot findSlotByName (in wstring name); */
NS_IMETHODIMP nsPKCS11ModuleDB::FindSlotByName(const PRUnichar *name, nsIPKCS11Slot **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIEnumerator listModules (); */
NS_IMETHODIMP nsPKCS11ModuleDB::ListModules(nsIEnumerator **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void toggleFIPSMode (); */
NS_IMETHODIMP nsPKCS11ModuleDB::ToggleFIPSMode()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean isFIPSEnabled; */
NS_IMETHODIMP nsPKCS11ModuleDB::GetIsFIPSEnabled(PRBool *aIsFIPSEnabled)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIPKCS11Slot_h__ */
